//+------------------------------------------------------------------+
//|                                       JJN-BigTrendL-31-pairs.mq4 |
//|                                      Copyright  2012, JJ Newark |
//|                                            http:/jjnewark.atw.hu |
//|                                             jjnewark@freemail.hu |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, JJ Newark"
#property link      "http:/jjnewark.atw.hu"


#property indicator_chart_window


//+------------------------------------------------------------------------------------------------------------------+
// YOU CAN CHANGE THESE PARAMETERS ACCORDING TO YOUR TASTE:
//+------------------------------------------------------------------------------------------------------------------+
int     tfnumber      = 7; // Number of the timeframes
int     tframe[]      = {5,15,60,240,1440,10080,43200}; // Timeframes in minutes
double  IndVal[][8]; // Be the second array-index equal with tfnumber//cjc
int     NumberOfPairs = 8; // Number of the pairs
string  Pairs[]       = {  "AUDUSD","EURJPY","EURUSD","GBPUSD","USDJPY","GER30","XAUUSD","US500"}; // Requested pairs
string  PLab[]        = {"5", "F", "H", "4", "D", "W", "M"};
//+------------------------------------------------------------------------------------------------------------------+
//+------------------------------------------------------------------------------------------------------------------+




extern int        TrendPeriod                 = 240;
extern int        Ma_Price                    = PRICE_CLOSE;
extern int        Ma_Mode                     = MODE_LWMA;
extern int        Ma_Shift                    =1;
extern color      UpColor                     = Lime;
extern color      DownColor                   = OrangeRed;
extern color      FlatColor                   = Gold;
extern color      FontColor                   = Yellow;
extern int        PosX                        = 20;
extern int        PosY                        = 20;
extern bool       ShowHeader                  = true;
extern bool       ShowSymbols                 = true;

double val_0,val_1;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {

   // Get any siffix used with this broker
   string suffix = StringSubstr(Symbol(), 6);
   
   int Indent = 0, j = 0, w = 0;
   if (ShowSymbols)
      Indent = 60;
      
   if(ShowHeader)
   {
      for(j=0; j < tfnumber; j++)
      {
         ObjectCreate("BigTrendLHed"+j,OBJ_LABEL,0,0,0,0,0);
         ObjectSet("BigTrendLHed"+j,OBJPROP_CORNER,0);
         ObjectSet("BigTrendLHed"+j,OBJPROP_XDISTANCE,j*16+PosX+Indent+3);
         ObjectSet("BigTrendLHed"+j,OBJPROP_YDISTANCE,PosY+16);
         ObjectSetText("BigTrendLHed"+j,PLab[j],8,"Tahoma",FontColor);
      } 
      PosY = PosY + 20;
   }

   for(w=0; w < NumberOfPairs; w++)
   {
      // Add suffix to each pair
      Pairs[w] = Pairs[w] + suffix;
      for(j=0; j < tfnumber; j++)
      {
         ObjectCreate("BigTrendLInd"+w+j,OBJ_LABEL,0,0,0,0,0);
         ObjectSet("BigTrendLInd"+w+j,OBJPROP_CORNER,0);
         ObjectSet("BigTrendLInd"+w+j,OBJPROP_XDISTANCE,j*16+PosX+Indent);
         ObjectSet("BigTrendLInd"+w+j,OBJPROP_YDISTANCE,w*16+PosY+10);
         ObjectSetText("BigTrendLInd"+w+j,CharToStr(110),12,"Wingdings",Silver);
      } 
   }
   
   if(ShowSymbols)
   {
      for(w=0; w < NumberOfPairs; w++)
      {
            ObjectCreate("BigTrendLPairs"+w,OBJ_LABEL,0,0,0,0,0);
            ObjectSet("BigTrendLPairs"+w,OBJPROP_CORNER,0);
            ObjectSet("BigTrendLPairs"+w,OBJPROP_XDISTANCE,PosX);
            ObjectSet("BigTrendLPairs"+w,OBJPROP_YDISTANCE,w*16+PosY+12);
            ObjectSetText("BigTrendLPairs"+w,Pairs[w],8,"Tahoma",FontColor);
      }
   }      
   if(ShowSymbols)
   {
      ObjectCreate("BigTrendLLine0",OBJ_LABEL,0,0,0,0,0);
      ObjectSet("BigTrendLLine0",OBJPROP_CORNER,0);
      ObjectSet("BigTrendLLine0",OBJPROP_XDISTANCE,PosX+10);
      ObjectSet("BigTrendLLine0",OBJPROP_YDISTANCE,NumberOfPairs*16+PosY+6);
      ObjectSetText("BigTrendLLine0","   ----------------------",8,"Tahoma",FontColor);
   
      ObjectCreate("BigTrendLLine1",OBJ_LABEL,0,0,0,0,0);
      ObjectSet("BigTrendLLine1",OBJPROP_CORNER,0);
      ObjectSet("BigTrendLLine1",OBJPROP_XDISTANCE,PosX+10);
      ObjectSet("BigTrendLLine1",OBJPROP_YDISTANCE,NumberOfPairs*16+PosY+8);
      ObjectSetText("BigTrendLLine1","   ----------------------",8,"Tahoma",FontColor);

      ObjectCreate("BigTrendLIndName",OBJ_LABEL,0,0,0,0,0);
      ObjectSet("BigTrendLIndName",OBJPROP_CORNER,0);
      ObjectSet("BigTrendLIndName",OBJPROP_XDISTANCE,PosX+20);
      ObjectSet("BigTrendLIndName",OBJPROP_YDISTANCE,NumberOfPairs*16+PosY+16);
      ObjectSetText("BigTrendLIndName","JJN-BigTrendLL ("+TrendPeriod+")",8,"Tahoma",FontColor);
   }
   
      
    
   ArrayResize(IndVal,NumberOfPairs); //cjc
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int w=0;w<NumberOfPairs;w++)
      {
      for(int j=0;j<tfnumber;j++)
      {
      ObjectDelete("BigTrendLInd"+w+j);
      ObjectDelete("BigTrendLHed"+j);
      }
      }   
      
   for(w=0;w<NumberOfPairs;w++)
      {
         ObjectDelete("BigTrendLPairs"+w);
      }
      
   ObjectDelete("BigTrendLLine0");
   ObjectDelete("BigTrendLLine1");
   ObjectDelete("BigTrendLIndName");
      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
   for(int z=0;z<NumberOfPairs;z++)
      {
   for(int x=0;x<tfnumber;x++)
      {
      
      val_0=iMA(Pairs[z],tframe[x],TrendPeriod,0,Ma_Mode,Ma_Price,0);
      val_1=iMA(Pairs[z],tframe[x],TrendPeriod,Ma_Shift,Ma_Mode,Ma_Price,0);
      //double adr0=(iHigh(Pairs[z],PERIOD_D1,0)-iLow(Pairs[z],PERIOD_D1,0))/Point/10;//cjc
      //double adr1=(iHigh(Pairs[z],PERIOD_D1,1)-iLow(Pairs[z],PERIOD_D1,1))/Point/10;//cjc      
        if (val_0 > val_1 && iLow(Pairs[z],tframe[x],0) > val_0) // UPTREND
        {
        IndVal[z][x]=1;
        }
        else if (val_0 < val_1 && iHigh(Pairs[z],tframe[x],0) < val_0) // DOWNTREND
        {
        IndVal[z][x]=-1;
        }
        else IndVal[z][x]=0; // RANGING
      }
      }
     
   
   for(int q=0;q<NumberOfPairs;q++)
      {
      for(int y=0;y<tfnumber;y++)
      {
         if(IndVal[q][y]==-1) ObjectSetText("BigTrendLInd"+q+y,CharToStr(110),12,"Wingdings",DownColor); //cjc
         if(IndVal[q][y]==0) ObjectSetText("BigTrendLInd"+q+y,CharToStr(110),12,"Wingdings",FlatColor); //cjc
         if(IndVal[q][y]==1) ObjectSetText("BigTrendLInd"+q+y,CharToStr(110),12,"Wingdings",UpColor); //cjc
      }
      }
     
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+